commit 05c9fdaa65d0ee25dff43ea241912b585da77b7a
Author: freddy77 <freddy77>
Date:   Thu May 21 16:35:21 2009 +0000

    improve continue_parse_prepared_query

diff --git a/ChangeLog b/ChangeLog
index 3eaf349..4e5cdfa 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu May 21 18:35:15 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/prepare_query.c: improve continue_parse_prepared_query
+
 Thu May 21 18:30:48 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/blob1.c: add wchar test
 
@@ -1559,4 +1562,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2791 2009/05/21 16:30:57 freddy77 Exp $
+$Id: ChangeLog,v 1.2792 2009/05/21 16:35:21 freddy77 Exp $
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index 5a2ed80..d9607dd 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.74 2008/11/12 10:38:15 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.75 2009/05/21 16:35:21 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -324,27 +324,20 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 	/* copy to destination */
 	if (blob) {
 		TDS_CHAR *p;
-		int dest_type, src_type, res;
-		CONV_RESULT ores;
-		TDS_DBC * dbc = stmt->dbc;
 		void *free_ptr = NULL;
 		SQLPOINTER extradata = NULL;
 		SQLLEN extralen = 0;
 
-		if (0 == (dest_type = odbc_sql_to_server_type(dbc->tds_socket, drec_ipd->sql_desc_concise_type))) {
-			odbc_errs_add(&stmt->errs, "07006", NULL); /* Restricted data type attribute violation */
-			return SQL_ERROR;
-		}
+		if (sql_src_type == SQL_C_CHAR) {
+			int dest_type, res;
+			CONV_RESULT ores;
+			TDS_DBC * dbc = stmt->dbc;
 
-		/* test source type */
-		/* TODO test intervals */
-		src_type = odbc_c_to_server_type(sql_src_type);
-		if (src_type == TDS_FAIL) {
-			odbc_errs_add(&stmt->errs, "07006", NULL); /* Restricted data type attribute violation */
-			return SQL_ERROR;
-		}
+			if (0 == (dest_type = odbc_sql_to_server_type(dbc->tds_socket, drec_ipd->sql_desc_concise_type))) {
+				odbc_errs_add(&stmt->errs, "07006", NULL); /* Restricted data type attribute violation */
+				return SQL_ERROR;
+			}
 
-		if (sql_src_type == SQL_C_CHAR) {
 			switch (tds_get_conversion_type(curcol->column_type, curcol->column_size)) {
 			case SYBBINARY:
 			case SYBVARBINARY:
@@ -352,9 +345,9 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 			case XSYBVARBINARY:
 			case SYBLONGBINARY:
 			case SYBIMAGE:
-				if (!*((char*)DataPtr+len-1))
+				if (len && !*((char*)DataPtr+len-1))
 					--len;
-					
+
 				if (!len)
 					return SQL_SUCCESS;
 					
@@ -364,7 +357,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 					data[0] = curcol->column_text_sqlputdatainfo;
 					data[1] = *(char*)DataPtr;
 				    
-					res = tds_convert(dbc->env->tds_ctx, src_type, data, 2, dest_type, &ores);
+					res = tds_convert(dbc->env->tds_ctx, SYBVARCHAR, data, 2, dest_type, &ores);
 					if (res < 0) {
 						odbc_convert_err_set(&dbc->errs, res);
 						return SQL_ERROR;
@@ -382,7 +375,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 					curcol->column_text_sqlputdatainfo = *((char*)DataPtr+len);
 				}
 
-				res = tds_convert(dbc->env->tds_ctx, src_type, DataPtr, len, dest_type, &ores);
+				res = tds_convert(dbc->env->tds_ctx, SYBVARCHAR, DataPtr, len, dest_type, &ores);
 				if (res < 0) {
 					odbc_convert_err_set(&dbc->errs, res);
 					free(extradata);

